# -*- coding: utf-8 -*-
"""
Created on Mon Apr 12 19:49:20 2021

@author: jeff
"""
import numpy as np
import cv2
import matplotlib.pyplot as plt
import imageio
import glob
from skimage.measure import label
import os



path_num = "M:/ipac2/210212drawon0212ex/patient/conlow/patient/image/gating"
#image reading path
image_path = r"%s/*.png" % path_num



 #saving path for platlet aggregrates
saving_path1 = r"%s/platelet_agg/IPAC" % path_num
os.makedirs(saving_path1)

 #saving path for WBC aggregrates
saving_path2 = r"%s/WBC_agg/IPAC" % path_num
os.makedirs(saving_path2)

 #saving path for WBC singlets
saving_path3 = r"%s/WBC_singlet/IPAC" % path_num
os.makedirs(saving_path3)

 #saving path for other samples
saving_path4 = r"%s/other/IPAC" % path_num
os.makedirs(saving_path4)




grayscale_img_list = [imageio.imread(file) for file in sorted(glob.glob(image_path))]

kernel = np.ones((2,2),np.uint8)
close_iter = 2
canny_low = 130
canny_high = 180
mask_erode_iter = 3
mask_dilate_iter = 2


print("total number of images", len(grayscale_img_list))

# lists to be used for simple canny based segmentation
area_list1 = []
small_image_list = []
small_area_list = []
test_large_image_list = []
test_large_area_list = []

count_list = []
contour_list = []
area_list = []
platelet_agg_list = []
platelet_agg_list_area = []
platelet_agg_list_object_count = []
platelet_agg_list_contour = []
WBC_list = []
WBC_list_area = []
WBC_list_object_count = []
WBC_agg = []
WBC_agg_area = []


other_list = []
other_list_area = []
test_list1 = []
test_list2 = []
test_list3 = []
test_list4 = []


large_object_img_check = []
large_object_num_check = []
large_object_contour_check = []


strange_object_list = []



for image in grayscale_img_list:
    img2 = cv2.convertScaleAbs(image, alpha = (255.0/image.max()))
    edges = cv2.Canny(img2, canny_low, canny_high)
    edges = cv2.dilate(edges, None, iterations = mask_dilate_iter)
    edges = cv2.erode(edges, None, iterations = mask_erode_iter)
    
    area1 = cv2.countNonZero(edges)
    area_list1.append(area1)
    
    if area1 <= 200:
        small_image_list.append(image)
        small_area_list.append(area1)
                    
        #####orginally 200 for first seperation
    if area1 > 200:
        test_large_image_list.append(image)
        test_large_area_list.append(area1)
        WBC_agg.append(image)
        WBC_agg_area.append(area1)
        
        
print(len(test_large_area_list))
print(len(small_image_list))

####lists to be used for further area based canny segmentations
area_list2 = []
below_100_list = []
below_100_list_area = []
above_100_list = []
above_100_list_area = []


for image in small_image_list:
    img2 = cv2.convertScaleAbs(image, alpha = (255.0/image.max()))
    edges = cv2.Canny(img2, canny_low, canny_high)
    edges = cv2.dilate(edges, None, iterations = mask_dilate_iter)
    edges = cv2.erode(edges, None, iterations = mask_erode_iter)
    
    area2 = cv2.countNonZero(edges)
    area_list2.append(area2)
    
    if area2 <= 100:
        below_100_list.append(image)
        below_100_list_area.append(area1)
                    
    if area2 > 100:
        above_100_list.append(image)
        above_100_list_area.append(area2)
        
        
print("small area list", len(below_100_list))
print("above 100 area list", len(above_100_list))


####lists for analysis


for img in below_100_list:
    img2 = cv2.convertScaleAbs(img, alpha = (255.0/img.max()))
    ret, thresh = cv2.threshold(img2, 0, 255, cv2.THRESH_BINARY_INV + cv2.THRESH_OTSU)
    
    opening = cv2.morphologyEx(thresh, cv2.MORPH_OPEN, kernel, iterations = 1)
    # closing = cv2.dilate(opening, kernel, iterations = close_iter)
    
    dist_transform = cv2.distanceTransform(opening, cv2.DIST_L2, 3)
    centers = (dist_transform > 0.3 * dist_transform.max())
    object_count = np.max(label(centers))
    # count_list.append(object_count)
    
    area3 = cv2.countNonZero(thresh)
    #_,
    contours2, _ = cv2.findContours(thresh, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_NONE)
    
    contour_list.append(len(contours2))
    # area_list.append(area)
    
    
    if object_count <= 2 and len(contours2) <= 2:
        # test_list3.append(img)
        # test_list4.append(pix_avg_intensity)
        if object_count == 1:
            # test_list4.append(len(contours))
            if len(contours2) == 1:
                # one_count_list_img.append(img)
                # one_count_list_area.append(area)
                WBC_list.append(img)
                WBC_list_area.append(area3)
            else:
                if area3 >= 50:
                    # one_count_list_img.append(img)
                    # one_count_list_area.append(area)
                    WBC_list.append(img)
                    WBC_list_area.append(area3)
                else:
                    # two_count_list.append(img)
                    # two_count_list_area.append(area)
                    platelet_agg_list.append(img)
                    platelet_agg_list_area.append(area3)
                    platelet_agg_list_object_count.append(object_count)
                    platelet_agg_list_contour.append(len(contours2))
        if object_count == 2:   
            if len(contours2) == 2:
                if area3 < 50:
                    # two_count_list.append(img)
                    # two_count_list_area.append(area)
                    platelet_agg_list.append(img)
                    platelet_agg_list_area.append(area3)
                    platelet_agg_list_object_count.append(object_count)
                    platelet_agg_list_contour.append(len(contours2))
                else:
                    # one_count_list_img.append(img)
                    # one_count_list_area.append(area)
                    WBC_list.append(img)
                    WBC_list_area.append(area3)
            else:
                if area3 >= 50:
                    # one_count_list_img.append(img)
                    # one_count_list_area.append(area)
                    WBC_list.append(img)
                    WBC_list_area.append(area3)
                else:
                    # two_count_list.append(img)
                    # two_count_list_area.append(area) 
                    platelet_agg_list.append(area3)
                    platelet_agg_list_area.append(area3)
                    platelet_agg_list_object_count.append(object_count)
                    platelet_agg_list_contour.append(len(contours2))
                
                
   ##### statements for seperating the images with more than 2 objects
                            
    else:
        if object_count <= 2:
            if area3 > 50:
                WBC_list.append(img)
                WBC_list_area.append(area3)
            else:
                platelet_agg_list.append(img)
                platelet_agg_list_area.append(area3)
                platelet_agg_list_object_count.append(object_count)
                platelet_agg_list_contour.append(len(contours2))
                
        if object_count in range(3, 11):
            if area3 > 50:
                WBC_list.append(img)
                WBC_list_area.append(area3)
            else:
                platelet_agg_list.append(img)
                platelet_agg_list_area.append(area3)
                platelet_agg_list_object_count.append(object_count)
                platelet_agg_list_contour.append(len(contours2))
        
        else:
            if object_count > 11:
                # if len(contours) < object_count:
                    
                other_list.append(img)
                other_list_area.append(area3)
                
print("number of aggregrates",len(platelet_agg_list))
print("number of WBC", len(WBC_list))
print("other list", len(other_list))
print("number of cells from small area", len(platelet_agg_list)+ len(WBC_list)+ len(other_list))






for img in above_100_list:
    img2 = cv2.convertScaleAbs(img, alpha = (255.0/img.max()))
    ret, thresh = cv2.threshold(img2, 0, 255, cv2.THRESH_BINARY_INV + cv2.THRESH_OTSU)
    
    opening = cv2.morphologyEx(thresh, cv2.MORPH_OPEN, kernel, iterations = 1)
    # closing = cv2.dilate(opening, kernel, iterations = close_iter)
    
    dist_transform = cv2.distanceTransform(opening, cv2.DIST_L2, 3)
    centers = (dist_transform > 0.3 * dist_transform.max())
    object_count = np.max(label(centers))
    count_list.append(object_count)
    
    area = cv2.countNonZero(thresh)
    #_, 
    contours, _ = cv2.findContours(thresh, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_NONE)
    
    contour_list.append(len(contours))
    area_list.append(area)
    
    
    if object_count <= 2 and len(contours) <= 2:
        #these are singlet WBC
        WBC_list.append(img)
        WBC_list_area.append(area)
        # test_list3.append(object_count)
        # test_list4.append(len(contours))
    else:
        if object_count > 3 and area < 65:
        #platelet aggregates
            platelet_agg_list.append(img)
            platelet_agg_list_area.append(area)
            
            # platelet_agg_list_object_count.append(object_count)
            # platelet_agg_list_contour.append(len(contours))
        else:
            if object_count >= 6 and len(contours) >= 6:
                #platelet aggregates that have many segmetations
                if area < 100:
                    platelet_agg_list.append(img)
                    platelet_agg_list_area.append(area)
                    
                else:
                    WBC_agg.append(img)
                    WBC_agg_area.append(area)
                
            else:
                if object_count <= 2:
                    if len(contours) >= 5:
                        #WBC + aggregates
                        WBC_agg.append(img)
                        WBC_agg_area.append(area)
                        
                    else:
                        if area > 95:
                            WBC_agg.append(img)
                            WBC_agg_area.append(area)
                        else:
                            WBC_list.append(img)
                            WBC_list_area.append(area)
                else:
                    if len(contours) >= 5:
                        if area < 75 :
                            platelet_agg_list.append(img)
                            platelet_agg_list_area.append(area)
                        else: 
                            WBC_agg.append(img)
                            WBC_agg_area.append(area)
                            
                    else:
                        if object_count >= 4:
                            WBC_agg.append(img)
                            WBC_agg_area.append(area)
                        else:
                            if area > 90:
                                WBC_agg.append(img)
                                WBC_agg_area.append(area)
                                
                            else:
                                WBC_list.append(img)
                                WBC_list_area.append(area)


print("total number of aggregrates",len(platelet_agg_list))
print("total number of WBC", len(WBC_list))
print("total other list", len(other_list))
print("total WBC agg count", len(WBC_agg))
print("number of cells from small area", len(platelet_agg_list)+ len(WBC_list)+ len(other_list)+ len(WBC_agg))

# platelet agg
for i, (filt_img, filt_area) in enumerate(zip(platelet_agg_list, platelet_agg_list_area)):
    cv2.imwrite(saving_path1 + f"{i}Area{filt_area}.png", filt_img)

# WBC agg    
for i, (filt_img, filt_area) in enumerate(zip(WBC_agg, WBC_agg_area)):
    cv2.imwrite(saving_path2 + f"{i}Area{filt_area}.png", filt_img)
   
# WBC singlet
for i, (filt_img, filt_area) in enumerate(zip(WBC_list, WBC_list_area)):
    cv2.imwrite(saving_path3 + f"{i}Filtered_image{filt_area}.png", filt_img)

# other 
for i, (filt_img, filt_area) in enumerate(zip(other_list, other_list_area)):
    cv2.imwrite(saving_path4 + f"{i}Filtered_image{filt_area}.png", filt_img)
